#include "path_checker.h"

bool
risc::traverser::is_defined_in_included_library(SgProject* project,
    SgNode* node)
{
  // get file of current node
  Sg_File_Info *fi = node->get_file_info();


  if(node->get_file_info() == NULL ||
      fi->get_raw_filename().length()  == 0 ||
      fi->get_raw_filename() == "compilerGenerated") {
    return false;
  }

  // buffer for the absolute path
  char path_buffer[fi->get_raw_filename().length()+1];

  // Create a path object that contains the absolute path for a file
  boost::filesystem::path
    class_path(realpath(fi->get_raw_filename().c_str(),path_buffer));

  // Remove the filename in the path
  class_path.remove_filename();

  // Iterate all include path that are given via command line
  for(SgStringList::iterator
      iter  = project->get_includeDirectorySpecifierList().begin();
      iter != project->get_includeDirectorySpecifierList().end();
      iter++){

    // create a path object of the path. We ignore the first two characters
    // because they are "-I"
    boost::filesystem::path file_from_include_path ((*iter).substr(2));

    //if they are equivalent, this class is defined in
    //the include path fodler
    if(boost::filesystem::equivalent(file_from_include_path , class_path)) {

      return true;
    }
  }

  return false;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
