%{

/*
 * lexer.l file
 * To generate the lexical analyzer run: "flex lexer.l"
 */

#include <stdio.h>
#include "parser.dynamic_analysis.tab.h"

%}

%option noyywrap

ADDRESS       0x[a-f0-9]+
POINTER       ->
NAME          [a-zA-Z][a-zA-Z0-9_.]*

LPAREN        [(]
RPAREN        [)]
WS            [\t\n\r ]+
COLON         [:]
DOT           [.]
COMMA         [,]
AT            [@]
PERCENT       [%]
AND           [&]
HASH          [#]
MINUS         [-]
DOLLAR        [$]
PLUS          [+]
GREATER       [>]
LESS          [<]
HAT           [\^]
WAVE          [~]
CURLY_OPEN    [{]
CURLY_CLOSE   [}]

QUESTION_MARK [?]

%%

{ADDRESS}       {
                  char *dynamic_analysistext_copy = (char*)malloc(sizeof(char) * strlen(dynamic_analysistext));
                  strcpy(dynamic_analysistext_copy, dynamic_analysistext);
                  dynamic_analysislval.Name = dynamic_analysistext_copy;

                  return T_ADDRESS;
                }
{POINTER}       { dynamic_analysislval.Pointer = dynamic_analysistext; return T_RISC_POINTER; }
{NAME}          {
                  char *dynamic_analysistext_copy = (char*)malloc(sizeof(char) * strlen(dynamic_analysistext));
                  strcpy(dynamic_analysistext_copy, dynamic_analysistext);
                  dynamic_analysislval.Name = dynamic_analysistext_copy;

                  return T_RISC_NAME;
                }

{LPAREN}        { return T_LPAREN;}
{RPAREN}        { return T_RPAREN;}

{COLON}         { return T_COLON; }
{DOT}           { return T_DOT; }
{COMMA}         { return T_COMMA; }
{AT}            { return T_AT; }
{PERCENT}       { return T_PERCENT; }
{AND}           { return T_AND; }
{HASH}          { return T_HASH; }
{MINUS}         { return T_MINUS; }
{DOLLAR}        { return T_DOLLAR; }
{PLUS}          { return T_PLUS; }
{CURLY_OPEN}    { return T_CURLY_OPEN; }
{CURLY_CLOSE}   { return T_CURLY_CLOSE; }
{GREATER}       { return T_GREATER; }
{LESS}          { return T_LESS; }
{HAT}           { return T_HAT; }
{WAVE}          { return T_WAVE; }
{QUESTION_MARK} { return T_QUESTION_MARK; }

{WS}            {}

%%

void dynamic_analysiserror(char const *s)
{
  fprintf (stderr, "%s\n", s);
  exit(1);
}

