#ifndef PRIMITIVE_CHANNEL_H_INCLUDED_
#define PRIMITIVE_CHANNEL_H_INCLUDED_

#include <vector>

#include "rose.h"

#include "class.h"
#include "interface.h"

namespace risc {

class PrimitiveChannelInstance;

class PrimitiveChannel: public Class {

public:

  /**
   * \brief Default constructor
   */
  explicit PrimitiveChannel(SgClassDefinition *ast_node);

  /**
   * \brief Returns all implemented interfaces
   */
  std::list<Interface*> get_interfaces();

  /**
   * List of instances of this channel in the design
   */
  std::list<PrimitiveChannelInstance*> instances_;

private:

  /**
   * \brief Disabled copy constructor
   */
  PrimitiveChannel(const PrimitiveChannel& pcd);
};

typedef std::vector<PrimitiveChannel*>
            PrimitiveChannelVector;
typedef std::vector<PrimitiveChannel*>::iterator
            PrimitiveChannelVectorIter;
typedef std::vector<PrimitiveChannel*>::const_iterator
            PrimitiveChannelVectorConstIter;

} // end namespace risc

#endif /* PRIMITIVE_CHANNEL_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
