#ifndef EDGE_H_INCLUDED_
#define EDGE_H_INCLUDED_

#include<iostream>

namespace risc{

namespace sg {


class Edge{

public:

  Edge():
    event_notification_edge_(false),
    hierarchical_communication_(false),
    time_units_(0)
  { }

  friend std::ostream& operator<< (std::ostream &out, const Edge &e)
  {
    return out;
  }

  /**
   * \brief    Indicates if this edge is for event notification
   */
  bool event_notification_edge_;

  /**
   * \brief    hierarchical_communication_ is colored pink
   */
  bool hierarchical_communication_;
  
  /**
   * \brief    Time advance for this edge
   */
  unsigned long long time_units_;
};


} // end of namesapce sg

} // end of namespace risc

#endif /* EDGE_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
