#include "file_classifier.h"

Rose::StringUtility::FileNameLibrary
risc::tools::get_library(int file_id)
{
  std::string sourceDirectory = Rose::getWorkingDirectory();
  std::string filename(Sg_File_Info::getFilenameFromID(file_id).c_str());

  Rose::StringUtility::FileNameClassification classification =
    Rose::StringUtility::classifyFileName(filename,sourceDirectory,
                       Rose::StringUtility::getOSType());

  return classification.getLibrary();
}

Rose::StringUtility::FileNameLibrary
risc::tools::get_library(Sg_File_Info* X)
{
  SgFile* file = TransformationSupport::getFile(X->get_parent());
  ROSE_ASSERT(file != NULL);
  std::string sourceFilename = file->getFileName();
  std::string sourceDirectory =
    Rose::StringUtility::getPathFromFileName(sourceFilename);

  Rose::StringUtility::FileNameClassification classification =
  Rose::StringUtility::classifyFileName(X->get_filenameString(),
      sourceDirectory, Rose::StringUtility::getOSType());

  return classification.getLibrary();
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
