#include "systemc.h"

class Interface: public sc_interface {

public:

  virtual void write() = 0;
};

class Channel: public Interface, sc_channel {

public:

  Channel(sc_module_name mn):
    sc_channel(mn)
  { }

  sc_event e;

  virtual void write()
  {
    wait(3, SC_FS);
    int first = 1;
    first++;
    wait(e);
    int second = 2;
    second++;
    wait(SC_ZERO_TIME);
    int third = 3;
    third++;
  }
};

class Module: public sc_module {
public:

  SC_HAS_PROCESS(Module);
  sc_port<Interface> port;


  Module(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    wait(SC_ZERO_TIME);
    port->write();
    wait(SC_ZERO_TIME);
    port->write();
    wait(SC_ZERO_TIME);
  }
};


class Top: public sc_module {
public:
  SC_HAS_PROCESS(Top);

  Top(sc_module_name mn):
    sc_module(mn),
    c("channel"),
    m("module")
  { }

  Channel c;
  Module m;

  void before_end_of_elaboration()
  {
    m.port.bind(c);
  }
};


int sc_main(int argc, char **argv)
{
  Top t("top");

  sc_start();

  return 0;
}
