#include <iostream>

#include "risc.h"

int main(int argc, char* argv[])
{
  std::cout << std::endl
            << "start processing file: " __FILE__
            << " ..."
            << std::endl;

  risc::Design d(argc,argv);


  std::cout << "main: "
            << risc::tools::CDefinitions::get_main()
            << std::endl;

  std::cout << "sc_main: "
            << risc::tools::SystemCDefinitions::get_sc_main()
            << std::endl;


  std::cout << "+++++++++++++++++++ Module Definitions "
               "+++++++++++++++++++++++++++++"
            << std::endl;

  // iterating all modules in the design
  for(risc::ModuleVectorIter
      iter  = d.module_definitions_.begin();
      iter != d.module_definitions_.end();
      iter++) {

    // print all sub modules in the individual module definitions
    (*iter)->print_module_definition();

    std::cout << std::endl;
  }


  std::cout << "+++++++++++++++++++ Top Modules "
               "+++++++++++++++++++++++++++++"
            << std::endl;

  // iterating all modules in the design
  for(risc::InstanceVectorIter
      iter  = d.top_modules_.begin();
      iter != d.top_modules_.end();
      iter++) {

    std::cout << "  " << (*iter)->get_ast_type_name()
              << " " << (*iter)->get_name() << std::endl;
  }


  std::cout << "end processing file: " __FILE__
            << " ..."
            << std::endl
            << std::endl;
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
