#include <iostream>

#include "risc.h"

int main(int argc, char* argv[])
{
  std::cout << std::endl
            << "start processing file: " __FILE__
            << " ..."
            << std::endl;

  risc::Design d(argc,argv);

  // iterating all modules in the design
  for(risc::ModuleVectorIter
      iter_module  = d.module_definitions_.begin();
      iter_module != d.module_definitions_.end();
      iter_module++) {

    std::cout << "Module: " <<  (*iter_module)->get_name() << std::endl;

    //(*iter_module)->print_module_definition();

    risc::sa::CThreadUninitializedVariablesSet potential_conflicts =
      risc::sa::inter_thread_analysis(*(*iter_module));

    std::cout << "  CThread" << std::endl;

    for(risc::sa::CThreadUninitializedVariablesSet ::iterator
        iter_pot_conf  = potential_conflicts.begin();
        iter_pot_conf != potential_conflicts.end();
        iter_pot_conf++) {

      std::cout << "    " << ((*iter_pot_conf)).first->get_name() << ": ";

      for(std::set<SgVariableSymbol*>::iterator
          iter_conflict_var  = ((*iter_pot_conf)).second.begin();
          iter_conflict_var != ((*iter_pot_conf)).second.end();
          iter_conflict_var++) {

        std::cout <<  (*iter_conflict_var)->get_name().getString() << " ";

      }
      std::cout << std::endl;
    }

    std::cout << std::endl;
  }

  std::cout << "end processing file: " __FILE__
            << " ..."
            << std::endl
            << std::endl;

  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
