#include <iostream>

#include "risc.h"

int main(int argc, char* argv[])
{
  std::cout << std::endl
            << "start processing file: " __FILE__
            << " ..."
            << std::endl;

  risc::Design d(argc,argv);

  // iterating all modules in the design
  for(risc::ModuleVectorIter
      iter_module  = d.module_definitions_.begin();
      iter_module != d.module_definitions_.end();
      iter_module++) {

    std::cout << "Module: " <<  (*iter_module)->get_name() << std::endl;

    (*iter_module)->print_module_definition();


    //risc::sa::inter_reset_cthread_analysis(*(*iter_module));


    std::cout << std::endl;
    std::cout << " Reset Behavior:" << std::endl;
    risc::sa::ResetSignalUninitializedVariablesSet reset_variables =
        risc::sa::inter_reset_cthread_analysis(*(*iter_module));


    for(risc::sa::ResetSignalUninitializedVariablesSet::iterator
        iter_reset_variables  = reset_variables.begin();
        iter_reset_variables != reset_variables.end();
        iter_reset_variables ++) {

      std::cout << "  " << (*iter_reset_variables).first->first->get_name() << ": ";

      for(std::set<SgVariableSymbol*>::iterator
          iter_conflict_var  = ((*iter_reset_variables)).second.begin();
          iter_conflict_var != ((*iter_reset_variables)).second.end();
          iter_conflict_var++) {

        std::cout <<  (*iter_conflict_var)->get_name().getString() << " ";

      }
      std::cout << std::endl;
    }

    std::cout << " Async Reset Behavior:" << std::endl;

    risc::sa::ResetSignalUninitializedVariablesSet async_reset_variables =
        risc::sa::inter_async_reset_cthread_analysis(*(*iter_module));

    for(risc::sa::ResetSignalUninitializedVariablesSet::iterator
        iter_reset_variables  = async_reset_variables.begin();
        iter_reset_variables != async_reset_variables.end();
        iter_reset_variables ++) {

      std::cout << "  " << (*iter_reset_variables).first->first->get_name() << ": ";

      for(std::set<SgVariableSymbol*>::iterator
          iter_conflict_var  = ((*iter_reset_variables)).second.begin();
          iter_conflict_var != ((*iter_reset_variables)).second.end();
          iter_conflict_var++) {

        std::cout <<  (*iter_conflict_var)->get_name().getString() << " ";

      }
      std::cout << std::endl;
    }
    std::cout << std::endl;
  }

  std::cout << "end processing file: " __FILE__
            << " ..."
            << std::endl
            << std::endl;

  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
